

#include <gtk/gtk.h>
#include <string.h>
#include <malloc.h>
#include <unistd.h>

#include "common.h"
#include "midi.h"


static GtkWidget *dlg_adj_pitch;
static GtkWidget *scale_pitch;
static GtkObject *adj_pitch;


static gint adj_pitch_dialog_ok(GtkWidget *widget, gpointer data);
static gint adj_pitch_dialog_cancel(GtkWidget *widget, gpointer data);



/*
  ȥåñ̤Υƥ
*/
gint adj_pitch_dialog(GtkWidget *widget, gpointer data)
{
  GtkWidget *button;

  dlg_adj_pitch = gtk_dialog_new();
  gtk_window_set_title(GTK_WINDOW(dlg_adj_pitch), "Pitch adjustment");
 
  gtk_widget_show(dlg_adj_pitch);

  adj_pitch = gtk_adjustment_new (midi_get_pitch_level(),
				     -2.0, 2.0, 0.01, 0.1, 0.1);
  scale_pitch = gtk_hscale_new (GTK_ADJUSTMENT (adj_pitch));
  gtk_widget_set_usize (GTK_WIDGET (scale_pitch), 150, 30);
  gtk_range_set_update_policy (GTK_RANGE (scale_pitch), 
			       GTK_UPDATE_DELAYED);
  gtk_scale_set_digits (GTK_SCALE (scale_pitch), 2); //ʲ
  gtk_scale_set_draw_value (GTK_SCALE (scale_pitch), TRUE); //ɽ
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg_adj_pitch)->vbox), 
		     scale_pitch, TRUE,TRUE,0);
  gtk_widget_show(scale_pitch);


  button = gtk_button_new_with_label("OK");
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg_adj_pitch)->action_area), 
		     button, TRUE,FALSE,3);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(adj_pitch_dialog_ok), (gpointer)0);
  gtk_widget_show(button);

  button = gtk_button_new_with_label("CANCEL");
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg_adj_pitch)->action_area), 
		     button, TRUE,FALSE,3);
  gtk_signal_connect(GTK_OBJECT(button), "clicked", 
		     GTK_SIGNAL_FUNC(adj_pitch_dialog_cancel), 
		     (gpointer)0);
  gtk_widget_show(button);
 
  gtk_window_set_default_size     (GTK_WINDOW(dlg_adj_pitch), 400,100);
  gtk_grab_add(GTK_WIDGET(dlg_adj_pitch));
  return 0;
}

// 饹٥ ѹ OK
static gint adj_pitch_dialog_ok(GtkWidget *widget, gpointer data)
{
  double pitch;
  pitch = (GTK_ADJUSTMENT(adj_pitch)->value);
  midi_set_pitch_level(pitch);
  gtk_widget_destroy(dlg_adj_pitch);
  return 0;
}

// pitchѹ 󥻥
static gint adj_pitch_dialog_cancel(GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy(dlg_adj_pitch);
  return 0;
}


