#ifndef __GENERAL_SETTING_H__
#define __GENERAL_SETTING_H__


typedef struct {
  char name[1024];
  char path[1024];
  unsigned long used_id;
} SOUNDFONT_NAME;

typedef struct {
  int timi_ctlrate;
  int timi_reverb;
  int timi_chorus;
  int timi_voices;
  char timi_location[1024];
  char timi_options[1024];
  char eca_location[1024];
  char eca_options[1024];
  int eca_enable;
  int sf_num;
  SOUNDFONT_NAME sf_name[128];
} GENERAL_SETTING;


void general_load_setting();
void general_save_setting();
char *general_get_default_vpofile();
int general_get_div_channel(int div);
void general_set_div_channel(int div, int ch);
int general_get_div_transpose(int div);
void general_set_div_transpose(int div, int tr);
char *general_get_recent_registration_file();
void general_set_recent_registration_file(char *file);
int general_get_div_loopback_dev(int div);
void general_set_div_loopback_dev(int div, int dev);
int general_get_input_dev();
void general_set_input_dev(int dev);
char *general_get_timidity_location();
void general_set_timidity_location(const char *location);

void general_set_soundfont_name(char *sf_name, char *path);
char* general_get_soundfont_path(char *sf_name, int flgAsk);
const char *general_get_rc_dir();

#define CH_OFF 99

#endif
