#ifndef __REGS_H__
#define __REGS_H__


typedef struct {
  int selected;
  int velocity;
  int bank;
  int preset;
  char stop_name[64];
} STOP;

typedef struct {
  char werk_name[64];
  STOP stops[STOP_NUM];
  int flg_tremulant;
  int coupler_sts[KB_NUM]; //ץ顼 [to-no]
} KB_STOPS;

typedef struct {
  int velocity[KB_NUM][STOP_NUM];
  int selected[KB_NUM][STOP_NUM];
  int tremulant[KB_NUM];
  int coupler[KB_NUM][KB_NUM];
} COMBINATION_MEMORY;

void regs_init();
char* regs_get_timidity_cmdline();
void regs_set_timidity_cmdline(char *cmdline);
int regs_get_current_tremulant_state(int div);
int regs_set_current_tremulant_state(int div, int sts);
int regs_get_current_coupler_state(int div, int to_div);
void regs_set_current_coupler_state(int div, int to_div, int sts);
char* regs_get_werk_name(int keyboard);
void  regs_set_werk_name(int keyboard, const char *name);
int regs_get_current_stop_select(int keyboard, int stopno);
void regs_set_current_stop_select(int keyboard, int stopno, int select);
int regs_get_current_stop_velocity(int keyboard, int stopno);
void regs_set_current_stop_velocity(int keyboard, int stopno, int velocity);
void regs_call_registration(int regno);
void regs_memory_regstration(int regno);
char* regs_get_stop_name(int keyboard, int stopno);
int regs_get_channel(int keyboard);
void regs_set_channel(int keyboard, int ch);
void regs_set_stop_name_all();
void regs_delete(int div, int stop);
void regs_insert(int div, int stop);
void regs_get_preset(int div, int stop, int *bank, int *preset);
void regs_set_preset(int div, int stop, int bank, int preset);
void regs_set_stop_name_all();
int regs_read_registration_table_file(char* table_fn);
int regs_write_registration_table_file(char* table_fn);
void regs_memory_registration(int regno);

char *regs_get_soundfont_name();
void regs_set_soundfont_name(char *sfname);


#endif


